想要在`BIMBase SDK`环境下实现自己的功能吗？在工程中添加如下代码，即可在BIMBase中注册自己的命令，实现弹出`Hello BIMBase`对话框。

```cpp
void HelloBIMBase()
	{
	     AfxMessageBox(L"Hello BIMBase!");
	}
	AutoDoRegisterFunctionsBegin
	BPToolsMessager::registerFun(_T("HelloBIMBase"), &HelloBIMBase);
	AutoDoRegisterFunctionsEnd
```


<div style="text-align: center;">
  <p>代码1-1 HelloBIMbase函数</p>
</div>

我们可以将以上代码分为两个步骤：
第一步：创建自己的`HelloBIMBase`函数，并在函数中弹出对话框。
第二步：通过BIMBase平台的接口 `BPToolsManager::registerFun`， 将第一步中所创建的`HelloBIMBase`函数注册到相关平台，并将其与命令`“HelloBIMBase”`关联。此时，`AutoDoRegisterFunctionsBegin`和`AutoDoRegisterFunctionsEnd`两个宏之间的代码会在相关模块加载时执行，即模块加载时`HelloBIMBase`被注册到平台。此时，启动BIMBase，在命令行输入已经注册的命令`“HelloBIMBase”`，执行后将弹出`HelloBIMBase`弹窗，如图1-1所示。

<div style="text-align:center;border:greensolid1px;">
<img src="/uploads/asd/images/image2.png" alt="" width="800" style="margin:0 auto;"/>
</div>
<center>图1-1 “Hello BIMBase”对话框<br />