BIMBase使用多文档模型，在BIMBase的类结构中，应用类和文档类是处于最顶层的，他们主要为`BPApplication`和`BPProject`这两类。
- 一个应用对象对应一个独立的BIMBase会话
`BPApplication`：提供访问程序相关资源的应用类，包括工程文件管理器、事务管理器访问。
- 一个工程对象对应一个独立的BIMBase工程文件<br />BIMBase可以同时有多个工程文件，每个工程可以同时有多个视图。如果有多个工程打开，那么处于最顶层或者活动的视图所在的工程就是活动工程。

## 2.4.1 BIMBase应用类
`BPApplication`表示一个BIMBase应用，提供对工程文件管理器、事务管理器的访问。<br />
- 工程文件管理器
用户可以通过`getProjectManager`接口获取`IBPProjectManager`对象，通过`IBPProjectManager`的方法实现工程的打开、获取、保存、关闭等。
- 事务管理器
用户可以通过`getTransactionManager`接口获取`BPTransactionManager`对象，通过`BPTransactionManager`的方法实现事务的管理与创建等。

## 2.4.2 BIMBase文档类

`BPProject`类用于表示打开的BIMBase工程，BIMBase可同时有多个工程打开，即同时拥有多个`BPProject`对象。`BPProject`对象用于存储BIMBase的元素、管理Model和数据。<br />

- 工程信息
用户可以通过`BPProject`获取工程文件全路径、Guid等信息；<br />
- 获取元素
用户可以通过`BPEntityId`获取对应的元素；
- 模型空间管理
一个BIMBase工程可以有多个模型空间，所有的图形对象都保存在模型空间上，通过`BPProject`类创建、查找、删除模型空间。