## 5.3.1 元素在视图中的可见性<br />
视图中记录了所有可见的元素。平台提供了隐藏视图中构件的接口，主要在`BPViewController`及`BPViewShowUtil`类中。<br />
<div style="text-align: center;">
  <p>表5-1 元素可见性接口列表</p>
</div>
<style>
    table {
        text-align: center;
    }
</style>

<table>
    <tr>
        <th>方法</th>
        <th>描述</th>
    </tr>
    <tr>
        <td rowspan="3">BPViewController</td>
        <td>	p3d::pset getHiddenEntities(BPViewportCR)</td>
    </tr>
    <tr>
        <td>clearHiddenEntities(BPViewportCP)</td>
    </tr>
	<tr>
        <td>	setHiddenEntities(p3d::pset, bool , BPViewportCP)</td>
    </tr>
	    <tr>
        <td rowspan="4">BPViewShowUtil</td>
        <td>	showOrHideEntities</td>
    </tr>
	    <tr>
        <td>showOrHideEntities</td>
    </tr>
	    <tr>
        <td>showAll</td>
    </tr>
	    <tr>
        <td>hideEntities</td>
    </tr>
</table>



通过提供的这些接口，可在指定视口批量显示或隐藏某些构件，并且实时获取被隐藏的构件。<br />

## 5.3.2 视图显示<br />
在三维视图中，通过三维导航工具可以任意旋转该视图，对于打开的视图可以设置背景色呈现不同的视图效果，根据视图显示的不同可以设置视图原点及比例等。在API中，可以通过以下接口来实现视图显示控制。<br />

<div style="text-align: center;">
  <p>表5-2 视图显示控制接口列表</p>
</div>
<style>
    table {
        text-align: center;
    }
</style>

<table>
    <tr>
        <th>方法</th>
        <th>描述</th>
    </tr>
    <tr>
        <td rowspan="11">BPViewport</td>
        <td>	UInt32 getBackgroundColor()</td>
    </tr>
    <tr>
        <td>setBackgroundColor(UInt32)</td>
    </tr>
	<tr>
        <td>		UInt32 getContrastToBKGColor()</td>
    </tr>
	<tr>
        <td>p3d::GeRotMatrix getRotMatrix()</td>
    </tr>
	<tr>
        <td>	p3d::GeRotMatrix getRotMatrix()</td>
    </tr>
	<tr>
        <td>p3d::GePoint3dCR getOrigin()</td>
    </tr>
	<tr>
        <td>	p3d::GePoint3dCR getDelta()</td>
    </tr>
	<tr>
        <td>p3d::GePoint3dCR getDelta()</td>
    </tr>
	<tr>
        <td>setRotMatrix(p3d::GeRotMatrixCR)</td>
    </tr>
	<tr>
        <td>setOrigin(p3d::GePoint3dCR)</td>
    </tr>
	<tr>
	    <td>	p3d::GePoint3dCP getScale()</td>
	</tr>
	    <tr>
        <td rowspan="3">BPViewShowUtil</td>
        <td>BPStandardView isStandardViewRotation(p3d::GeRotMatrixCR , bool)</td>
    </tr>
	    <tr>
        <td>::p3d::P3DStatus setAllow3DManipulations(int , const BPRotateAxisOption)</td>
    </tr>
	    <tr>
        <td>::p3d::P3DStatus getAllow3DManipulations(int , OUT BPRotateAxisOption)</td>
    </tr>
</table>


其中在`BPViewManager`对3D视图进行控制的接口中，`BPRotateAxisOption`中对应的操作为`enRotateNone->`不可以做任何3D旋转，`enRotateAxisX->`仅可以围绕X轴进行3D旋转，`enRotateAxisY->`仅可以围绕Y轴进行3D旋转，`enRotateAxisZ->`仅可以围绕Z轴进行3D旋转，`enRotateAny->`可以围绕任意轴做3D旋转。<br />