事件是BIMBase界面或者API在执行过程中特定时机触发的特定动作。通过注册事件，一个插件程序能在某个动作触发的前后得到通知，然后根据这个动作采取相应的行动。事件通常是成对的，其中一个在某个动作发生前触发，称为预备事件，另一个在某个动作发生后触发，称为事后事件。对于单独出现的事件，我们称之为单一事件。

BIMBase中事件较为丰富，能满足客户在特定场景下特定时机进行定制化处理。BIMBase提供了应用级别的事件包括工程（Project）事件、专业（Domain）事件、视图（View）事件、右键菜单事件、构件（Entity）事件、构件显示变化事件、命令事件等。

BIMBase中主要事件包括：
<div style="text-align: center;">
  <p>表6-1 事件列表</p>
</div>
<style>
    table {
        text-align: center;
    }
</style>

<table>
    <tr>
        <td rowspan="5">工程事件
（BPProjectEventListener）
</td>
        <td>工程打开前事件</td>
		<td>_onPreOpen</td>
    </tr>
    <tr>
        <td>工程打开后事件</td>
		<td>_onPostOpen</td>
    </tr>
	<tr>
        <td>工程关闭前事件</td>
		<td>_onPreClose</td>
    </tr>
	    <tr>
        <td>工程关闭后事件</td>
        <td>_onPostClose</td>
    </tr>
	    <tr>
        <td>工程保存前事件</td>
		<td>_onPreSave</td>
	</tr>
	<tr>
        <td rowspan="7">构件选择事件(BPEntitySelectedEventListener)
</td>
        <td>选择前通知事件</td>
		<td>onPreSelected</td>
    </tr>
    <tr>
        <td>选择后通知事件</td>
		<td>onPostSelected</td>
    </tr>
	<tr>
        <td>选择集拦截事件</td>
		<td>onCaptureSelected</td>
    </tr>
	    <tr>
        <td>无构件选中单击事件</td>
        <td>onSelectedNothing</td>
    </tr>
	    <tr>
        <td>构件双击通知事件</td>
		<td>onDoubleClickEvent</td>
	</tr>
	    <tr>
        <td>被选择构件单击事件</td>
		<td>onClickEvent</td>
	</tr>
	<tr>
        <td>构件反选事件</td>
		<td>onReverseSelected</td>
	</tr>
	<td rowspan="2">框架事件
(BPMainFrameEventListener)
</td>
        <td>框架创建后事件</td>
		<td>_onPostCreate</td>
</td>
</tr>
	    <tr>
        <td>框架关闭前事件</td>
		<td>_onPreClose</td>
	</tr>
<td >右键菜单事件
(BPViewRButtonClickListener)
</td>
        <td>设置专业右键菜单事件</td>
		<td>_setMenu</td>
</td>
    <tr>
        <td rowspan="4">构件显隐事件
(BPHideEntitySetEventListener)
</td>
        <td>构件隐藏前事件</td>
		<td>_onPreHide</td>
    </tr>
    <tr>
        <td>构件隐藏后事件</td>
		<td>_onPostHide</td>
    </tr>
	<tr>
        <td>构件显示前事件</td>
		<td>_onPreShow</td>
    </tr>
	    <tr>
        <td>构件显示后事件</td>
        <td>_onPostShow</td>
    </tr>
        <td rowspan="7">构件选择事件(BPEntitySelectedEventListener)
</td>
        <td>选择前通知事件</td>
		<td>onPreSelected</td>
    </tr>
    <tr>
        <td>选择后通知事件</td>
		<td>onPostSelected</td>
    </tr>
	<tr>
        <td>选择集拦截事件</td>
		<td>onCaptureSelected</td>
    </tr>
	    <tr>
        <td>无构件选中单击事件</td>
        <td>onSelectedNothing</td>
    </tr>
	<tr>
        <td>构件双击通知事件</td>
		<td>onDoubleClickEvent</td>
    </tr>
	<tr>
        <td>被选择构件单击事件</td>
		<td>onClickEvent</td>
    </tr>
	    <tr>
        <td>构件反选事件</td>
        <td>onReverseSelected</td>
    </tr>
	 <td rowspan="6">构件改变事件
(BPObjectChangeEventListener)
</td>
        <td>新增构件前事件</td>
		<td>_onPreNew</td>
		</tr>
    <tr>
        <td>新增构件后事件</td>
		<td>_onPostNew</td>
    </tr>
	<tr>
        <td>编辑构件前事件</td>
		<td>_onPreEdit</td>
    </tr>
	    <tr>
        <td>编辑构件后事件</td>
        <td>_onPostEdit</td>
    </tr>
	    <tr>
        <td>删除构件前事件</td>
		<td>_onPreDelete</td>
	</tr>
	    <tr>
        <td>被选择构件单击事件</td>
		<td>onClickEvent</td>
	</tr>
	 <td rowspan="4">菜单事件
(BPRibbonEventListener)
</td>
        <td>切换专业前菜单更新事件</td>
		<td>onPreChangeDiscipline</td>
		</tr>
    <tr>
        <td>切换专业后菜单更新事件</td>
		<td>onPostChangeDiscipline</td>
    </tr>
	<tr>
        <td>改变菜单前事件</td>
		<td>onPreChangeCategory</td>
    </tr>
	    <tr>
        <td>改变菜单后事件</td>
        <td>onPostChangeCategory</td>
    </tr>
	<tr>
        <td>构件显示变化事件
(BPEntitySymbologyEventListener)</td>
		<td>构件显示变化事件</td>
		<td>_getOverrides</td>
    </tr>
	    <tr>
        <td>命令事件
(BPCommandEventListener)</td>
        <td>命令事件</td>
		<td>onPreExeCommand</td>
    </tr>
</table>