
|字段分类|名称|含义|有效性说明|
|-----|-----|-----|-----|
|schema首部字段|Schema名称|整个Schema内容的总名称|不能为空，仅支持英文；不能以数字、特殊符号开头；|
||命名空间前缀|Schema名称前作为区分标识|一般采用Schema名称的缩写；|
||Schema版本|描述版本信息|遵循“主版本.次版本”格式，开发者自行维护|
||显示名称|用于编辑器和程序内部使用|一般与Schema名称保持一致|
||Schema全名|与命名空间前缀一起作为标识|由Schema名称和APIKey的哈希值默认生成|
||描述信息|解释当前schema的用途|自定义|
|Reference字段|ReferenceSchema信息|引用schema信息，同schema首部字段|编辑器支持直接选中待引用的schema,自动获取该字段信息；|
|Class字段Class字段|Class名称|class的标识字段|建议使用有标识意义的字段|
||显示名称|编辑器和软件内部使用|一般同Class名称|
||Schema|class所属的schema名称|新建class时默认生成|
||描述|补充描述信息|可省略；|
||IsStruct|是否为结构体|结构体属性信息中的TypeName|
||IsCustomAttributeClass|是否为自定义属性|默认Flase，（预留使用）|
||IsDomainClass|是否支持实例化|默认True|
||BaseClass|引用的基类|手动选择其他可以引用类的信息|
||Name|属性名称|建议选择又标识的字段|
||OriginClass|所属的class|默认自动生成|
||Overrides|是否重载|默认生成false|
||DisplayLable|显示名称|一般与Name保持一致|
||TypeName|描述属性值的类型|支持选择项包括基本数据类型和PKPMEntity字段“描述信息”IsStruct为True的class|
||Description|描述信息|可选|
||IsArray|当前属性为数组存储多个变量|默认为False|
||MinOccurs|最少数量|IsArray设置为True时有效，有效默认值为1|
||MaxOccurs|最多数量|IsArray设置为True时有效，有效默认值为1|
||ReadOnly|只读|默认False|
||Priority|优先权|（预备使用）|
||Releation|描述两个Class关联关系|设置Releationship Class自动生成|
||Source|关联关系中的源Class|设置Releationship Class自动生成|
||Target|关联关系中的目标Class|设置Releationship Class自动生成|
|Relationship Class字段Relationship Class字段|Name|引用schema信息，同表1中字段；|具有标识性即可|
||DisplayLable|显示名称|具有标识性即可|
||Schema|当前关联关系所属的schema|自动生成|
||Description|描述信息|自行确定|
||BaseClass|继承的基类|可选当前schema和引用schema中class|
||Strength|描述关联的强度|(预留使用)|
||StringthDirection|描述关联的方向|可选前向和后向|
||SourceCardinality|源class的基数，描述源实例与目标实例对应关系中源类实例的数量要求|可取值为(0,1)和(0,N)|
||SourcePolymorphic|继承当前source class的子class是否添加为当前关系的source class|默认为True|
||SourceClass|源class|可选用当前schmea和引用schema中的class|
||TargetCardinality|目标class的基数，描述源实例与目标实例对应关系（一对一、一对多...）中目标类实例的数量要求|可取值为(0,1)和(0,N)|
||TargetPolymorphic|继承当前target class的子class是否添加为当前关系的target class|默认为True|
||TargetClass|源class|可选用当前schmea和引用schema中的class|

<br />
